/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

#ifndef rt_xtt_cmd_h
#define rt_xtt_cmd_h

#ifndef pwr_h
# include "pwr.h"
#endif

#ifndef xtt_xnav_h
# include "xtt_xnav.h"
#endif

#ifndef co_dcli_input_h
# include "co_dcli_input.h"
#endif

class XttCmd {
  public:
    XttCmd();
    
    XNav 		*xnav;
    dcli_sChannel 	chn;
    dcli_sRecall 	*recall_buf;

    static void usage();
    static void message_cb( void *ctx, char severity, const char *msg);
    static void close_cb( void *ctx, int terminate);
  
    static xnav_sStartMenu alarm_menu[];
    static xnav_sStartMenu nethandler_menu[];
    static xnav_sStartMenu communication_menu[];
    static xnav_sStartMenu logging_menu[];
    static xnav_sStartMenu system_menu[];
    static xnav_sStartMenu root_menu[];
};

#endif
