/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 **/

#ifndef cow_login_motif_h
#define cow_login_motif_h

#ifndef cow_login_h
#include "cow_login.h"
#endif

struct login_widgets 
{                                             
  Widget	toplevel;
  Widget	login_window;
  Widget	label;
  Widget        adb;
  Widget	usernamevalue;
  Widget	passwordvalue;
};

class CoLoginMotif : public CoLogin {
 public:
  Widget	parent_wid;
  struct login_widgets	widgets;

  CoLoginMotif( void		*wl_parent_ctx,
	       Widget       	wl_parent_wid,
	       const char      	*wl_name,
	       const char      	*wl_groupname,
	       void		(* wl_bc_success)( void *),
	       void		(* wl_bc_cancel)( void *),
	       pwr_tStatus   	*sts);
  ~CoLoginMotif();

  pwr_tStatus get_values();
  void message( const char *new_label);

  static void activate_ok( Widget w, CoLogin *loginctx, XmAnyCallbackStruct *data);
  static void activate_cancel( Widget w, CoLogin *loginctx, XmAnyCallbackStruct *data);
  static void create_label( Widget w, CoLogin *loginctx, XmAnyCallbackStruct *data);
  static void create_adb( Widget w, CoLogin *loginctx, XmAnyCallbackStruct *data);
  static void create_usernamevalue( Widget w, CoLogin *loginctx, XmAnyCallbackStruct *data);
  static void create_passwordvalue( Widget w, CoLogin *loginctx, XmAnyCallbackStruct *data);
  static void valchanged_passwordvalue( Widget w, CoLogin *loginctx, XmAnyCallbackStruct *data);
  static void valchanged_usernamevalue( Widget w, CoLogin *loginctx, XmAnyCallbackStruct *data);
};

#endif
