/** 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 **/

#ifndef cow_xhelp_motif_h
#define cow_xhelp_motif_h

#ifndef cow_xhelp_h
# include "cow_xhelp.h"
#endif

class CoXHelpMotif : public CoXHelp {
  public:
    CoXHelpMotif( 
	Widget 		xa_parent_wid, 
	void 		*xa_parent_ctx,
	xhelp_eUtility  utility,
	int             *xa_sts);
    Widget	parent_wid;
    Widget	brow_widget;
    Widget	form_widget;
    Widget	toplevel;
    Widget	xhelpnav_form;
    XtIntervalId focus_timerid;
    Widget	india_widget;
    Widget	india_label;
    Widget	india_text;

    void set_dimension( int width, int height);    
    static void open_input_dialog( CoXHelpMotif *xhelp, const char *text, const char *title,
				   char *init_text,
				   void (*ok_cb)( CoXHelp *, char *));
    static void activate_exit( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void activate_zoom_in( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void activate_zoom_out( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void activate_zoom_reset( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void activate_search( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void activate_searchnext( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void activate_searchprevious( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void create_india_label( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void create_india_text( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void activate_india_ok( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void activate_india_cancel( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void activate_help( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void create_xhelpnav_form( Widget w, CoXHelpMotif *xhelp, XmAnyCallbackStruct *data);
    static void enable_set_focus( CoXHelpMotif *xhelp);
    static void disable_set_focus( CoXHelpMotif *xhelp, int time);
    static void action_inputfocus( Widget w, XmAnyCallbackStruct *data);

    static Widget get_widget() { 
      if ( default_xhelp)
	return ((CoXHelpMotif *)default_xhelp)->parent_wid;
      else
	return 0;
    }

    ~CoXHelpMotif();
};

#endif







