/** 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 **/

#ifndef cow_xhelp_h
#define cow_xhelp_h

#ifndef pwr_h
# include "pwr.h"
#endif

#ifndef cow_xhelpnav_h
# include "cow_xhelpnav.h"
#endif

class CoXHelp {
  public:
    CoXHelp( 
	void 		*xa_parent_ctx,
	xhelp_eUtility  utility,
	int             *xa_sts);
    void 	*parent_ctx;
    char 	name[80];
    CoXHelpNav	*xhelpnav;
    void	*client_data;
    void	(*close_cb) ( void *, void *);
    void 	(*open_URL_cb)( void *, char *);
    int		set_focus_disabled;
    int         displayed;
    void	(*india_ok_cb)( CoXHelp *, char *);

    static CoXHelp *default_xhelp;

    virtual void set_dimension( int width, int height) {}
    virtual void pop();
    virtual void print() {}

    void map();
    void clear();
    int help( const char *key, const char *help_bookmark, navh_eHelpFile file_type,
	      const char *file_name, bool strict);
    int	help_index( navh_eHelpFile file_type, const char *file_name);
    int home();
    int back();
    int next_topic();
    int previous_topic();
    void activate_print() { print();}
    static void set_default( CoXHelp *xhelp) { default_xhelp = xhelp;}
    static int dhelp( const char *key, const char *help_bookmark, navh_eHelpFile file_type,
		      const char *file_name, bool strict);
    static int	dhelp_index( navh_eHelpFile file_type, const char *file_name);

    static void open_URL( void *ctx, char *url);
    static void open_input_dialog( CoXHelp *xhelp, const char *text, const char *title,
				   char *init_text,
				   void (*ok_cb)( CoXHelp *, char *));
    static void find_ok( CoXHelp *xhelp, char *search_str);
    
    virtual ~CoXHelp();
};


#endif







