/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 **/

#ifndef flow_pdf_h
#define flow_pdf_h

#include <stdio.h>
#include "flow.h"
#include "flow_print.h"

class CnvToPdf;

class FlowPdf : public FlowPrint {
  public:
    FlowPdf( char *filename, void *flow_ctx, int page_border, int *sts);
    ~FlowPdf();
     int type() { return print_eType_Pdf;}
     int print_page( double ll_x, double ll_y, double ur_x, double ur_y);
     int rect( double x, double y, double width, double height, flow_eDrawType type, double idx, int highlight);
     int filled_rect( double x, double y, double width, double height, flow_eDrawType type, double idx);
     int arc( double x, double y, double width, double height, int angel1, int angel2,
		flow_eDrawType type, double idx, int highlight);
     int line( double x1, double y1, double x2, double y2, flow_eDrawType type, double idx, int highlight);
     int text( double x, double y, char *text, int len,  flow_eDrawType type, double size, int line);
     int pixmap( double x, double y, flow_sPixmapDataElem *data, flow_eDrawType type);
     int arrow( double x1, double y1, double x2, double y2, 
	double x3, double y3, flow_eDrawType type, double idx);
     void move( double x, double y);
     void setlinewidth( double idx);
     void rowbreak();
     void set_showred( int show) { show_red = show;}
     double offset_x;
     double offset_y;
     FILE *file;
     char fname[80];
     int border;
     void *ctx;
     int show_red;
     CnvToPdf *topdf;
};

#endif
