/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

#ifndef xtt_block_gtk_h
#define xtt_block_gtk_h

/* xtt_block_gtk.h -- Alarm blocking window */

#ifndef xtt_block_h
# include "xtt_block.h"
#endif

class BlockGtk : public Block {
  public:
    BlockGtk( void *b_parent_ctx,
		GtkWidget *b_parent_wid,
		pwr_sAttrRef *b_oar,
		char *name,
		unsigned int priv,
		pwr_tStatus *status);
    ~BlockGtk();
    int execute();
    void update();

    GtkWidget		*parent_wid;
    GtkWidget		*toplevel;
    GtkWidget		*form;
    GtkWidget		*toggleA;
    GtkWidget		*toggleB;
    GtkWidget		*toggleC;
    GtkWidget		*toggleD;
    GtkWidget		*toggleNo;
    GtkWidget		*buttonOk;
    GtkWidget		*buttonApply;

    static void activate_ok( GtkWidget *w, gpointer data);
    static void activate_cancel( GtkWidget *w, gpointer data);
    static void activate_apply( GtkWidget *w, gpointer data);
};

#endif



