/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

#ifndef xtt_evala_gtk_h
#define xtt_evala_gtk_h

/* xtt_evala_gtk.h -- Alarm window in xtt */

#ifndef xtt_evala_h
# include "xtt_evala.h"
#endif

class EvAlaGtk : public EvAla {
  public:
    EvAlaGtk(
	void *ev_parent_ctx,
	GtkWidget *ev_parent_wid,
	char *ala_name,
	pwr_tObjid ev_user,
	int ev_eventname_seg,
	int ev_width,
	int ev_height,
	int ev_x,
	int ev_y,
	pwr_tObjid ev_view,
	unsigned int ev_options,
	void *widget,
	pwr_tStatus *status);
    ~EvAlaGtk();

    GtkWidget		*parent_wid;
    GtkWidget		*parent_wid_ala;
    GtkWidget		*toplevel;
    GtkWidget		*ala_widget;
    GtkWidget		*ala_vbox;
    pwr_tObjid		alarm_views[25];

    void map_ala();
    void unmap_ala();
    void set_title_ala( char *title);
    GtkWidget *get_widget() { return ala_vbox;}

    static gboolean ala_action_inputfocus( GtkWidget *w, GdkEvent *event, gpointer data);
    static void ala_activate_exit( GtkWidget *w, gpointer data);
    static void ala_activate_print( GtkWidget *w, gpointer data);
    static void ala_activate_ack_last( GtkWidget *w, gpointer data);
    static void ala_activate_ack_all( GtkWidget *w, gpointer data);
    static void ala_activate_zoom_in( GtkWidget *w, gpointer data);
    static void ala_activate_zoom_out( GtkWidget *w, gpointer data);
    static void ala_activate_zoom_reset( GtkWidget *w, gpointer data);
    static void ala_activate_open_plc( GtkWidget *w, gpointer data);
    static void ala_activate_display_in_xnav( GtkWidget *w, gpointer data);
    static void ala_activate_disp_hundredth( GtkWidget *w, gpointer data);
    static void ala_activate_hide_object( GtkWidget *w, gpointer data);
    static void ala_activate_hide_text( GtkWidget *w, gpointer data);
    static void ala_activate_help( GtkWidget *w, gpointer data);
    static void ala_activate_helpevent( GtkWidget *w, gpointer data);
    static void ala_activate_shift_view( GtkWidget *w, gpointer data);
    static void ala_activate_select_flat( GtkWidget *w, gpointer data);
    static void ala_activate_select_view1( GtkWidget *w, gpointer data);
    static void ala_activate_select_view2( GtkWidget *w, gpointer data);
    static void ala_activate_select_view3( GtkWidget *w, gpointer data);
    static void ala_activate_select_view4( GtkWidget *w, gpointer data);
    static void ala_activate_select_view5( GtkWidget *w, gpointer data);
    static void ala_activate_select_view6( GtkWidget *w, gpointer data);
    static void ala_activate_select_view7( GtkWidget *w, gpointer data);
    static void ala_activate_select_view8( GtkWidget *w, gpointer data);
    static void ala_activate_select_view9( GtkWidget *w, gpointer data);
    static void ala_activate_select_view10( GtkWidget *w, gpointer data);
    static void ala_activate_select_view11( GtkWidget *w, gpointer data);
    static void ala_activate_select_view12( GtkWidget *w, gpointer data);
    static void ala_activate_select_view13( GtkWidget *w, gpointer data);
    static void ala_activate_select_view14( GtkWidget *w, gpointer data);
    static void ala_activate_select_view15( GtkWidget *w, gpointer data);
    static void ala_activate_select_view16( GtkWidget *w, gpointer data);
    static void ala_activate_select_view17( GtkWidget *w, gpointer data);
    static void ala_activate_select_view18( GtkWidget *w, gpointer data);
    static void ala_activate_select_view19( GtkWidget *w, gpointer data);
    static void ala_activate_select_view20( GtkWidget *w, gpointer data);
    static void ala_activate_select_view21( GtkWidget *w, gpointer data);
    static void ala_activate_select_view22( GtkWidget *w, gpointer data);
    static void ala_activate_select_view23( GtkWidget *w, gpointer data);
    static void ala_activate_select_view24( GtkWidget *w, gpointer data);
    static void ala_activate_select_view25( GtkWidget *w, gpointer data);
};

#endif



