/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

#ifndef xtt_evlist_gtk_h
#define xtt_evlist_gtk_h

/* xtt_evlist_gtk.h -- Alarm and event windows in xtt */

#ifndef xtt_evlist_h
# include "xtt_evlist.h"
#endif

class EvListGtk : public EvList {
  public:
    EvListGtk(
	void *ev_parent_ctx,
	GtkWidget *ev_parent_wid,
	ev_eType ev_type,
	int ev_size,
	int ev_evenname_seg,
	GtkWidget **w,
	void (*ev_init_cb)(void *) = 0);
    ~EvListGtk();

    GtkWidget		*parent_wid;
    GtkWidget		*brow_widget;
    GtkWidget		*form_widget;
    GtkWidget		*toplevel;
    char		print_title[120];

    void set_input_focus();
    void bell();
    void print( const char *title);
    void popup_position( int x_event, int y_event, int *x, int *y);
};


#endif
