/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

#ifndef xtt_methodtoolbar_gtk_h
#define xtt_methodtoolbar_gtk_h

#include "xtt_methodtoolbar.h"

class XttMethodToolbarGtk;

typedef struct {
  XttMethodToolbarGtk *mt;
  int idx;
} xtt_sMethodButtonCb;
  
class XttMethodToolbarGtk : public  XttMethodToolbar {
 public:
  GtkWidget *m_toolbar_w;
  GtkWidget *m_button_w[m_size];
  xtt_sMethodButtonCb m_cb[m_size];
  gint 	    m_timerid;

  XttMethodToolbarGtk( void *parent_ctx, void *xnav, unsigned int method_mask, 
		       const char *tooltip_suffix);
  ~XttMethodToolbarGtk();
  GtkWidget *build();
  void set_sensitive();
  void set_current_sensitive();

  static void activate_button( GtkWidget *w, gpointer data);
  static gboolean set_sensitive_cb( void *data);

};

#endif
