/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

#ifndef xtt_xcolwind_gtk_h
#define xtt_xcolwind_gtk_h

/* xtt_xcolwind_gtk.h -- Collect window */

#ifndef xtt_xcolwind_h
# include "xtt_xcolwind.h"
#endif

#ifndef cow_wow_gtk_h
# include "cow_wow_gtk.h"
#endif



class XColWindGtk : public XColWind {
 public:
  XColWindGtk ( 
	GtkWidget      	*xa_parent_wid, 
	void 		*xa_parent_ctx, 
	pwr_sAttrRef 	*xa_objar,
	char		*xa_title,
	int 		xa_advanced_user,
	xcolwind_eType	xa_type,
	int             *xa_sts);
    ~XColWindGtk();
    GtkWidget	*parent_wid;
    GtkWidget	*brow_widget;
    GtkWidget	*form_widget;
    GtkWidget	*toplevel;
    GtkWidget	*msg_label;
    GtkWidget	*cmd_prompt;
    GtkWidget	*cmd_input;
    GtkWidget	*cmd_scrolledinput;
    GtkWidget	*cmd_scrolledtextview;
    GtkWidget	*cmd_scrolled_ok;
    GtkWidget	*cmd_scrolled_ca;
    GtkTextBuffer *cmd_scrolled_buffer;
    GtkWidget	*pane;
    static CoWowRecall value_recall;
    CoWowEntryGtk *cmd_entry;
    CoWowFocusTimerGtk focustimer;
    int input_max_length;

    void message( char severity, const char *message);
    void set_prompt( const char *prompt);
    void change_value( int set_focus);
    int open_changevalue( char *name);
    void change_value_close();
    void pop();
    void set_title( char *title);
    void set_window_size( int w, int h);
    void get_window_size( int *w, int *h);
    void print();

    static void activate_open( GtkWidget *w, gpointer data);
    static void activate_save( GtkWidget *w, gpointer data);
    static void activate_saveas( GtkWidget *w, gpointer data);
    static void activate_insert( GtkWidget *w, gpointer data);
    static void activate_delete( GtkWidget *w, gpointer data);
    static void activate_print( GtkWidget *w, gpointer data);
    static void activate_moveup( GtkWidget *w, gpointer data);
    static void activate_movedown( GtkWidget *w, gpointer data);
    static void activate_change_value( GtkWidget *w, gpointer data);
    static void activate_close_changeval( GtkWidget *w, gpointer data);
    static void activate_exit( GtkWidget *w, gpointer data);
    static void activate_display_object( GtkWidget *w, gpointer data);
    static void activate_show_cross( GtkWidget *w, gpointer data);
    static void activate_open_classgraph( GtkWidget *w, gpointer data);
    static void activate_open_plc( GtkWidget *w, gpointer data);
    static void activate_zoomin( GtkWidget *w, gpointer data);
    static void activate_zoomout( GtkWidget *w, gpointer data);
    static void activate_zoomreset( GtkWidget *w, gpointer data);
    static void activate_scantime1(GtkWidget *w, gpointer data);
    static void activate_scantime2(GtkWidget *w, gpointer data);
    static void activate_scantime3(GtkWidget *w, gpointer data);
    static void activate_scantime4(GtkWidget *w, gpointer data);
    static void activate_scantime5(GtkWidget *w, gpointer data);
    static void activate_help( GtkWidget *w, gpointer data);
    static gboolean action_inputfocus( GtkWidget *w, GdkEvent *event, gpointer data);
    static void valchanged_cmd_input( GtkWidget *w, gpointer data);
    static void activate_cmd_input( GtkWidget *w, gpointer data);
    static void activate_cmd_scrolled_ok( GtkWidget *w, gpointer data);
    static void activate_cmd_scrolled_ca( GtkWidget *w, gpointer data);
    static void action_text_inserted( GtkTextBuffer *w, GtkTextIter *iter, gchar *str, gint len, gpointer data);
    
};

#endif







