/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

#ifndef xtt_block_motif_h
#define xtt_block_motif_h

/* xtt_block_motif.h -- Alarm blocking window */

#ifndef xtt_block_h
# include "xtt_block.h"
#endif

class BlockMotif : public Block {
  public:
    BlockMotif( void *b_parent_ctx,
		Widget b_parent_wid,
		pwr_sAttrRef *b_oar,
		char *name,
		unsigned int priv,
		pwr_tStatus *status);
    ~BlockMotif();
    int execute();
    void update();

    Widget		parent_wid;
    Widget		toplevel;
    Widget		form;
    Widget		toggleA;
    Widget		toggleB;
    Widget		toggleC;
    Widget		toggleD;
    Widget		toggleNo;
    Widget		buttonOk;
    Widget		buttonApply;

    static void create_ok( Widget w, Block *blk, XmAnyCallbackStruct *data);
    static void create_apply( Widget w, Block *blk, XmAnyCallbackStruct *data);
    static void create_toggleA( Widget w, Block *blk, XmAnyCallbackStruct *data);
    static void create_toggleB( Widget w, Block *blk, XmAnyCallbackStruct *data);
    static void create_toggleC( Widget w, Block *blk, XmAnyCallbackStruct *data);
    static void create_toggleD( Widget w, Block *blk, XmAnyCallbackStruct *data);
    static void create_toggleNo( Widget w, Block *blk, XmAnyCallbackStruct *data);
    static void activate_ok( Widget w, Block *blk, XmAnyCallbackStruct *data);
    static void activate_cancel( Widget w, Block *blk, XmAnyCallbackStruct *data);
    static void activate_apply( Widget w, Block *blk, XmAnyCallbackStruct *data);
};

#endif



