/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

#ifndef xtt_clog_motif_h
#define xtt_clog_motif_h

/* xtt_clog_motif.h -- Alarm and event windows in xtt */

#ifndef xtt_clog_h
# include "xtt_clog.h"
#endif

class CLogMotif : public CLog {
  public:
    CLogMotif( void *clog_parent_ctx,
	       Widget	clog_parent_wid,
	       const char *clog_name,
	       pwr_tStatus *status);
    ~CLogMotif();

    Widget		parent_wid;
    Widget		parent_wid_clog;
    Widget		toplevel;
    Widget		form_clog;
    Widget		clognav_widget;
    Widget		filter_form;
    Widget		show_success_w;
    Widget		show_info_w;
    Widget		show_warning_w;
    Widget		show_error_w;
    Widget		show_fatal_w;
    Widget		show_text_w;
    Widget		filter_string_w;
    Widget		filesel_form;
    Widget		filesel_list_w;
    int			clock_cursor;

    void pop();
    void set_clock_cursor();
    void reset_cursor();
    void free_cursor();

    static void action_inputfocus( Widget w, XmAnyCallbackStruct *data);
    static void activate_exit( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void activate_select_file( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void activate_next_file( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void activate_prev_file( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void activate_update( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void activate_zoom_in( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void activate_zoom_out( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void activate_zoom_reset( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void activate_filter( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void activate_help( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void activate_helpmsg( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void create_form( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void filter_tog_cr( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void filter_string_cr( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void filter_act_but_cb( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void filesel_list_cr( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void filesel_ok_cb( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    static void filesel_cancel_cb( Widget w, CLog *clog, XmAnyCallbackStruct *data);
    
};

#endif




