/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

/* xtt_clog.cpp -- Console log in xtt */

#include "glow_std.h"

#include <stdio.h>
#include <stdlib.h>

#include "co_cdh.h"
#include "co_time.h"
#include "pwr_baseclasses.h"
#include "rt_gdh.h"

#include "co_lng.h"
#include "cow_wow.h"
#include "xtt_clog.h"
#include "rt_xnav_msg.h"

CLog::CLog( void *clog_parent_ctx,
	    const char *clog_name,
	    pwr_tStatus *status) :
  parent_ctx(clog_parent_ctx),
  clognav(NULL), clog_displayed(0), help_cb(0), close_cb(0), filesel_loaded(false)
{
  *status = 1;
}


//
//  Delete clog
//
CLog::~CLog()
{
}

void CLog::activate_next_file()
{
  set_clock_cursor();
  if ( !clognav->next_file())
    wow->DisplayError( "File error", "No next file found");
  reset_cursor();
}

void CLog::activate_prev_file()
{
  set_clock_cursor();
  if ( !clognav->prev_file())
    wow->DisplayError( "File error", "No previous file found");
  reset_cursor();
}

void CLog::activate_print()
{
  print();
}

void CLog::activate_help()
{
  if ( help_cb)
    (help_cb)( parent_ctx, "opg_nav_systemmsg");
}



