/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

#ifndef xtt_clog_h
#define xtt_clog_h

/* xtt_clog.h -- Alarm and event windows in xtt */

#ifndef pwr_h
# include "pwr.h"
#endif

#ifndef xtt_clognav
# include "xtt_clognav.h"
#endif

class CoWow;

class CLog {
  public:
    CLog( void *clog_parent_ctx,
	  const char *clog_name,
	  pwr_tStatus *status);
    virtual ~CLog();

    void 		*parent_ctx;
    char 		name[80];
    CLogNav		*clognav;
    int			clog_displayed;
    void 		(*help_cb)( void *, const char *);
    void 		(*close_cb)( void *);
    bool		filesel_loaded;
    CoWow		*wow;

    virtual void pop() {}
    virtual void set_clock_cursor() {}
    virtual void reset_cursor() {}
    virtual void free_cursor() {}
    virtual void print() {}

    void activate_next_file();
    void activate_prev_file();
    void activate_print();
    void activate_help();
};

#endif




