/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

#ifndef xtt_xatt_h
#define xtt_xatt_h

/* xtt_xatt.h -- Object attribute editor */

#ifndef pwr_h
# include "pwr.h"
#endif

class XAttNav;

class XAtt {
  public:
    XAtt( 
	void 		*xa_parent_ctx, 
	pwr_sAttrRef 	*xa_objar,
	int 		xa_advanced_user,
	int             *xa_sts);
    virtual ~XAtt();
    void 	*parent_ctx;
    pwr_sAttrRef objar;
    char 	name[80];
    XAttNav	*xattnav;
    void	*root_item;
    int		input_open;
    int         input_multiline;
    void 	*object;
    void	(*close_cb) ( void *, void *);
    void	(*redraw_cb) (void *);
    void 	(*popup_menu_cb)( void *, pwr_sAttrRef, unsigned long,
				  unsigned long, char *, int x, int y);
    int         (*call_method_cb)(void *, const char *, const char *, pwr_sAttrRef,
				  unsigned long, unsigned long, char *);
    int		(*is_authorized_cb)(void *, unsigned int);
    void	*client_data;
    brow_tObject input_node;
    char	input_name[80];

    virtual void message( char severity, const char *message) {}
    virtual void set_prompt( const char *prompt) {}
    virtual void change_value( int set_focus) {}
    virtual void change_value_close() {}
    virtual void pop() {}
    virtual void print() {}

    int open_changevalue( char *name);
    void swap( int mode);
    int object_attr();
    void activate_display_object();
    void activate_show_cross();
    void activate_open_classgraph();
    void activate_open_plc();
    void activate_help();
    void activate_print();

    static void xatt_popup_menu_cb( void *ctx, pwr_sAttrRef attrref,
			       unsigned long item_type, unsigned long utility,
			       char *arg, int x, int y);
    static int xatt_is_authorized_cb( void *ctx, unsigned int access);
    static void message_cb( void *xatt, char severity, const char *message);
    static void change_value_cb( void *xatt);
    static int init_cb( void *ctx);
};

#endif







