/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2012 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

#ifndef xtt_xnav_brow_h
#define xtt_xnav_brow_h

typedef enum {
  brow_eUserType_XNav,
  brow_eUserType_XAttNav
} brow_eUserType;

class XNavBrow {
  public:
    XNavBrow( BrowCtx *brow_ctx, void *brow_userdata, brow_eUserType brow_usertype) : 
      ctx(brow_ctx), userdata(brow_userdata), usertype(brow_usertype)
      { strcpy( push_command, "");};
#if 0
    ~XNavBrow();
#endif

    BrowCtx		*ctx;
    void		*userdata;
    brow_eUserType	usertype;
    brow_tNodeClass 	nc_object;
    brow_tNodeClass 	nc_attr;
    brow_tNodeClass 	nc_table;
    brow_tNodeClass 	nc_text;
    brow_tNodeClass 	nc_header;
    brow_tNodeClass 	nc_headerlarge;
    brow_tNodeClass 	nc_table_header;
    brow_tNodeClass 	nc_enum;
    flow_sAnnotPixmap 	*pixmap_leaf;
    flow_sAnnotPixmap 	*pixmap_map;
    flow_sAnnotPixmap 	*pixmap_openmap;
    flow_sAnnotPixmap	*pixmap_ref;
    flow_sAnnotPixmap 	*pixmap_crossref;
    flow_sAnnotPixmap 	*pixmap_openattr;
    flow_sAnnotPixmap 	*pixmap_attr;
    flow_sAnnotPixmap 	*pixmap_attrarray;
    flow_sAnnotPixmap 	*pixmap_attrarrayelem;
    flow_sAnnotPixmap 	*pixmap_crrread;
    flow_sAnnotPixmap 	*pixmap_crrwrite;
    flow_sAnnotPixmap 	*pixmap_script;
    flow_sAnnotPixmap 	*pixmap_list;
    flow_sAnnotPixmap 	*pixmap_graph;
    flow_sAnnotPixmap 	*pixmap_curve;
    flow_sAnnotPixmap 	*pixmap_action;
    flow_sAnnotPixmap 	*pixmap_file;
    flow_sAnnotPixmap 	*pixmap_symbol;
    flow_sAnnotPixmap 	*pixmap_morehelp;
    flow_sAnnotPixmap 	*pixmap_closehelp;
    flow_sAnnotPixmap 	*pixmap_object;
    flow_sAnnotPixmap 	*pixmap_attrenum;
    flow_sAnnotPixmap 	*pixmap_attrmask;
    flow_sAnnotPixmap 	*pixmap_block2;
    flow_sAnnotPixmap 	*pixmap_blockd;
    flow_sAnnotPixmap 	*pixmap_blockr;
    flow_sAnnotPixmap 	*pixmap_alarm2;
    flow_sAnnotPixmap 	*pixmap_arrowdown;
    flow_sAnnotPixmap 	*pixmap_arrowright;
    flow_sAnnotPixmap 	*pixmap_attrref;
    flow_sAnnotPixmap 	*pixmap_castattr;
    flow_sAnnotPixmap 	*pixmap_plcpgm;
    flow_sAnnotPixmap 	*pixmap_inverted;
    flow_sAnnotPixmap 	*pixmap_teston;
    flow_sAnnotPixmap 	*pixmap_offline;
    char                push_command[200];

    void free_pixmaps();
    void allocate_pixmaps();
    void create_nodeclasses();
    void brow_setup();
    void set_push_command( char *cmd) { strcpy(push_command, cmd);};
};

#endif
